<?
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */

	$db = pg_connect($db_connect_str);

	$totals = pg_exec($db, "select	t1.AccountNumber as accountnumber,
					t1.accountname as accountname,
					t1.credit as credit,
					date(t1.DateCreated) as DateCreated,
					date(t1.DateClosed) as DateClosed,
					t2.debit as debit,
					t3.uncleared as uncleared
				  from	(select	SUM(cr.credit) as credit,
						acc.AccountNumber as AccountNumber,
						acc.Name as AccountName,
						acc.DateCreated as DateCreated,
						acc.DateClosed as DateClosed
					   FROM	(account_credits cr right outer join Accounts acc on (cr.AccountNumber = acc.AccountNumber))
					  GROUP	BY acc.AccountNumber,
						   acc.Name,
						   acc.DateCreated,
						   acc.DateClosed
					) t1
					left outer join
					(select	acc2.AccountNumber as AccountNumber,
						trim(acc2.name) as accountname,
						(SUM(po.shippinghandling + po.othercharges)
						+SUM(pi.unitprice * pi.quantity)) as debit
					   from		PurchaseOrders po left outer join PurchaseItems pi on (pi.PurchaseID = po.id)
						right outer join
							Accounts acc2 on (po.accountnumber = acc2.accountnumber)
					  where	po.AccountNumber = acc2.AccountNumber
					    AND	(po.cancelled Is Null Or po.cancelled = 'false')
					  GROUP	BY acc2.name,
						   acc2.AccountNumber
					) t2 on (t1.AccountNumber = t2.AccountNumber)
					left outer join
				        (select acc2.AccountNumber as AccountNumber,
				                trim(acc2.name) as accountname,
				                (SUM(po.shippinghandling + po.othercharges) +SUM(pi.unitprice * pi.quantity)) as uncleared
				           from PurchaseOrders po left outer join PurchaseItems pi on (pi.PurchaseID = po.id)
				                right outer join Accounts acc2 on (po.accountnumber = acc2.accountnumber)
				          where po.AccountNumber = acc2.AccountNumber
				            AND (po.cancelled Is Null Or po.cancelled = 'false')
				            AND (po.cleared Is Null Or po.cleared = 'false')
				          GROUP BY
				                acc2.name,
				                acc2.AccountNumber
				        ) t3 on (t1.AccountNumber = t3.AccountNumber)
				  ORDER	BY DateClosed, accountname DESC"
			  );

?>
<html><head><title>Past Orders by Account</title>
	<link rel=StyleSheet href="credit.css" type="text/css">
    </head>
    <body>

	<? commonHeader("browse");?>

      <table border=0 width=50% cellspacing=0 cellpadding=3>
        <tr>
	  <th>Account</th>
	  <th>Opened</th>
	  <th>Closed</th>
	  <th>Debits</th>
	  <th>Uncleared</th>
	  <th>Running Balance</th>
	  <th></th>
	</tr>
<?
	$grand_total = 0;
	$grand_debits = 0;
	if ($totals != false) {
	    for( $n = pg_numrows($totals) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($totals, $n);
		$balance = $row["credit"] - $row["debit"];
		printf("<tr><td nowrap><a href=\"".$this_page."?form=list_orders&account=%s\">%s (%s)</a></td><td nowrap class=\"report_medium\">%s</td><td nowrap class=\"report_medium\">%s</td><td nowrap>$%s<td class=\"report_medium\"><a href=\"?form=list_orders&account=%s&cleared=false\"><font color=red>$%s</a></font></td></td><td nowrap>$%s</td><td nowrap class=\"report_medium\"><a href=\"".$this_page."?form=adjust_credit&account=%s\">Adjust</a></td></tr>\n", $row["accountnumber"], $row["accountnumber"], $row["accountname"], $row["datecreated"], $row["dateclosed"], number_format($row["debit"], 2), $row["accountnumber"], number_format($row["uncleared"], 2), number_format($balance, 2), $row["accountnumber"]);
		$grand_total += $balance;
		$grand_debits += $row["debit"];
	    }
	}
?>
	<tr><td colspan=6><hr></td></tr>
	<tr><td><a href="<?echo($this_page)?>?form=list_orders">View all orders</a></td><td colspan=2></td><td>$<? print(number_format($grand_debits, 2)); ?></td><td>$<? print(number_format($grand_total, 2)); ?></td></tr>
      </table>
    </body>
</html>
<?
	pg_close($db);
	
	exit;

?>
