<?
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */

	require_once("pdf-table.php");

	$pdf = PDF_new();
        $current_page_number = 0;

        /* letter paper dimensions */
        $pwidth = 72 * 8.5;
        $pheight = 72 * 11;
        $h4_font = 20.0;
        $p_font = 12.0;
        $font = "";

	$relative_ypos = 0;

        function needsPageBreak($num_added) {
            global $relative_ypos;
            if ( ($relative_ypos - $num_added)/72.0 < 0.25 ) {
                return true;
            } return false;
        }

        function gotoNextPage() {
            global $current_page_number;
            global $pdf;
            global $pwidth;
            global $pheight;
            global $font;
            global $p_font;
            global $h4_font;
            global $relative_ypos;

            if ($current_page_number > 0) {
                PDF_end_page($pdf);
            }

	    PDF_begin_page($pdf, $pwidth, $pheight);
            $relative_ypos = ($pheight - $h4_font * 3.5);


            # Change "host" encoding to "winansi" or whatever you need!
            $font = PDF_findfont($pdf, "Helvetica", "host", 0);
            PDF_setfont($pdf, $font, $p_font);

            /* BEGIN watermark */
            if (isset($_REQUEST["show_sample"]) &&
                $_REQUEST["show_sample"] != "") {
                pdf_save($pdf);
	        pdf_setcolor($pdf, "both", "rgb", 0.5, 0.5, 0.5, $dummy=1.0);
                PDF_setfont($pdf, $font, $h4_font*8);
                pdf_rotate($pdf, -45);
                PDF_set_text_pos($pdf, -$pwidth/1.3, $pheight/1.4);
                PDF_show($pdf, "Sample");
                pdf_restore($pdf);
            } else if (isset($order_cancelled) && $order_cancelled == true) {
                pdf_save($pdf);
	        pdf_setcolor($pdf, "both", "rgb", 0.5, 0.5, 0.5, $dummy=1.0);
                PDF_setfont($pdf, $font, $h4_font*8);
                pdf_rotate($pdf, -45);
                PDF_set_text_pos($pdf, -$pwidth/1.3, $pheight/1.6);
                PDF_show($pdf, "Cancelled");
                pdf_restore($pdf);
            }
            /* END watermark */

            $current_page_number++;

            return $relative_ypos;
        }/* gotoNextPage() */

	if (empty($date_ordered)) {
	    $date_ordered = date("d-M-Y");
	}

	$db = pg_connect($db_connect_str);
	$personnel = pg_exec($db, "select trim(firstname) as firstname, trim(lastname) as lastname from personnel where id = ".$requestor);
	$ordered_by = pg_fetch_array($personnel, 0);

	$shiptoaddrs = pg_exec($db, "select trim(name) as name, trim(streetaddress1) as streetaddress1, trim(streetaddress2) as streetaddress2, trim(zip) as zip from shiptoaddresses where id = ".$shipto);
	$shiptoaddr = pg_fetch_array($shiptoaddrs, 0);

	$vendors = pg_exec($db, "select trim(name) as name, trim(streetaddress1) as streetaddress1, trim(streetaddress2) as streetaddress2, trim(city) as city, trim(state) as state, trim(zip) as zip, trim(country) as country, trim(phone) as phone, trim(fax) as fax, trim(web) as web from vendors where id = ".$company);
	$vendor = pg_fetch_array($vendors, 0);
	$country = $vendor["country"];

	pg_close($db);

	PDF_open_file($pdf, "");

	PDF_set_info($pdf, "Creator", $this_page);
	PDF_set_info($pdf, "Author", "Spencer Eugene Olson");
	PDF_set_info($pdf, "Title", "Credit Card Order Form");

        gotoNextPage();

	# Credit Card Order Form Title
	pdf_save($pdf);
	PDF_setfont($pdf, $font, $h4_font);
	PDF_set_text_pos($pdf, 20, ($pheight - 30));
	PDF_show($pdf, "Credit Card Order Form");
	pdf_restore($pdf);

	pdf_save($pdf);
	PDF_setfont($pdf, $font, $p_font/2);
	PDF_set_text_pos($pdf, 20, ($pheight - 30 - $h4_font/2));
	PDF_show($pdf, "po_id:  ".$po_id);
	pdf_restore($pdf);

	// Credit Card Number
	pdf_save($pdf);
	pdf_setcolor($pdf, "both", "rgb", 0.5, 0.5, 0.5, $dummy=1.0);
	pdf_show_boxed($pdf, "Credit Card Number:", $pwidth - ($p_font*25), ($pheight-45), 0, 0, "left", "");
	pdf_rect($pdf, $pwidth - ($p_font*25), ($pheight-45 - $p_font*0.5), ($p_font*22), ($p_font*2));
	pdf_stroke($pdf);
	pdf_restore($pdf);

	# Ordered by Section
	PDF_set_text_pos($pdf, 20, $relative_ypos);
	PDF_show($pdf, "Requested by:  ".$ordered_by["firstname"]." ".$ordered_by["lastname"]);
	PDF_continue_text($pdf, "Approved by:  " . $approved);
	PDF_continue_text($pdf, "Phone:  " . $phone);

	# Dates and Account number
	PDF_set_text_pos($pdf, ($pwidth - $p_font*20), $relative_ypos);
	PDF_show($pdf, "Today's Date:  " . $date_ordered);
	PDF_continue_text($pdf, "Date Needed:  " . $date_needed);
	PDF_continue_text($pdf, "Account:  " . $account);

	# Shipping
	$relative_ypos -= $p_font * 4;
	PDF_set_text_pos($pdf, 20, $relative_ypos);
	if ($ship_method != "Other") {
	    PDF_show($pdf, "Method of Shipment:  ".$ship_method);
	} else {
	    PDF_show($pdf, "Method of Shipment:  ");
	}

	if ($ship_method_details != "") {
	    $__nc_last__ = 1000000; /* some big number of chars */
	    $nr = 1;
	    while (($__nc__ = pdf_show_boxed($pdf, $ship_method_details, 43, $relative_ypos-$p_font*$nr, $pwidth - 63,$p_font*$nr, "left","blind")) > 1) {
		if($__nc__ == $__nc_last__) {
		    break;
		} else {
		    $nr += 1;
		    $__nc_last__ = $__nc__;
		}
	    }
	    PDF_show_boxed($pdf, $ship_method_details, 43, $relative_ypos-$p_font*$nr, $pwidth - 63, $p_font*$nr, "left", "");
	}

        # Quotation Number
        if ($quote_number != "") {
            pdf_set_parameter($pdf, "underline", "true");
            PDF_show_boxed($pdf, "Quotation No.:  ".$quote_number, $pwidth - ($p_font*25), $relative_ypos, 0, 0, "left", "");
            pdf_set_parameter($pdf, "underline", "false");
        }


	#END REQUEST HEADER

	# top separation bar
	PDF_continue_text($pdf, "");
	pdf_save($pdf);
	$relative_ypos -= $p_font * ($ship_method_details != "" ? ($nr+1) : 1);
	pdf_setcolor($pdf, "both", "rgb", 0.0, 0.0, 1.0, $dummy=1.0);
	pdf_setlinewidth($pdf, 4.0);
	pdf_moveto($pdf, $pwidth-10, $relative_ypos);
	pdf_lineto($pdf, 10, $relative_ypos);
	pdf_stroke($pdf);
	pdf_restore($pdf);

	/* BEGIN TABLE */
	  /* header */
	$item_table = new PDFTable();

	$item_table->setHeader(
	    array(
		/* values must be single quoted strings to prevent
		 * variable substitution */
		"Quantity" => '$quantity',
		"Unit"=> '$unit',
		"Description"  => '$description',
		"Unit Price"=> '$unit_price',
		"Total"=> '$total'
		),
	    array(
		/* general and specific settings for columns */
		"Quantity_width" => ($p_font*4),
		"Quantity_align" => "center",
		"Quantity_fontsize" => $p_font,

		"Unit_width"=> ($p_font*10),
		"Unit_align" => "center",
		"Unit_fontsize" => $p_font,

		"Description_width"  => ($p_font*20),
		"Description_align" => "center",
		"Description_fontsize" => $p_font,

		"Unit Price_width"=> ($p_font*6),
		"Unit Price_align" => "center",
		"Unit Price_fontsize" => $p_font,

		"Total_width"=> ($p_font*6),
		"Total_align" => "center",
		"Total_fontsize" => $p_font,
		)
	    );

	 /* BEGIN rows */
	$grand_total = $shipping_charges + $other_charges;
	for ( $n = 0; $n < $max_num_items; $n++ ) {
	    if (!empty(${"qty".$n})) {
		$item_table->appendRow(
		    array(
			"quantity" => ${"qty".$n},
			"unit"=> ${"unit".$n},
			"description"  => ${"desc".$n},
			"unit_price"=> "$".number_format(${"price".$n}, 2),
			"total"=> "$".number_format(${"qty".$n}*${"price".$n}, 2)
		    )
		);
		$grand_total += (${"qty".$n} * ${"price".$n});
	    }
	}

	 /* END ROWS */

	pdf_save($pdf);
	$table_info = $item_table->show($pdf, 20, ($relative_ypos-= $p_font*2));
        /* getHeight returns the height on the last page of the table. */
	$relative_ypos -= $item_table->getHeight();
	pdf_restore($pdf);

	/* shipping and handling */
        if (needsPageBreak($p_font*3)) { gotoNextPage(); }
	pdf_save($pdf);

	$x = $table_info["Total_x"];
	$w = $table_info["Total_width"];

	pdf_show_boxed($pdf, "Shipping & Handling", 0, $relative_ypos, $x-1, $p_font, "right", "");
	pdf_show_boxed($pdf, "$".number_format($shipping_charges,2), $x, $relative_ypos, $w, $p_font, "center", "");
	pdf_rect($pdf, $x, $relative_ypos - $p_font*.2, $w, $p_font);
	pdf_stroke($pdf);
	$relative_ypos -= $p_font * 1;

	pdf_show_boxed($pdf, "Other", 0, $relative_ypos, $x-1, $p_font, "right", "");
	pdf_show_boxed($pdf, "$".number_format($other_charges,2), $x, $relative_ypos, $w, $p_font, "center", "");
	pdf_rect($pdf, $x, $relative_ypos - $p_font*.2, $w, $p_font);
	pdf_stroke($pdf);
	$relative_ypos -= $p_font * 1;

	pdf_show_boxed($pdf, "Total", 0, $relative_ypos, $x-1, $p_font, "right", "");
	pdf_show_boxed($pdf, "$".number_format($grand_total,2), $x, $relative_ypos, $w, $p_font, "center", "");
	pdf_rect($pdf, $x, $relative_ypos - $p_font*.2, $w, $p_font);
	pdf_stroke($pdf);
	$relative_ypos -= $p_font * 1;

	pdf_restore($pdf);
        /* end shipping and handling. */
	/* END TABLE */


        /* add some blank space. */
	$relative_ypos -= $p_font * 1;


	/* BEGIN Vendor Information */
        $vendor_ysize = 7;
        if (needsPageBreak($p_font*$vendor_ysize)) { gotoNextPage(); }

	PDF_set_text_pos($pdf, 20, $relative_ypos);
	PDF_show($pdf, "Name:  ");
	PDF_continue_text($pdf, "Street:  ");
	if ($vendor["streetaddress2"] != "") {
	    PDF_continue_text($pdf, "         ");
	}
	PDF_continue_text($pdf, "City, St  ZIP:  ");
	if ($country != "USA") {
	    PDF_continue_text($pdf, "Country:  ");
	}
	PDF_continue_text($pdf, "Phone:  ");
	PDF_continue_text($pdf, "Fax:  ");
	PDF_continue_text($pdf, "Web:  ");
	PDF_continue_text($pdf, "Contact:  ");

	PDF_set_text_pos($pdf, 20 + $p_font*8, $relative_ypos);
	PDF_show($pdf, $vendor["name"]);
	PDF_continue_text($pdf, $vendor["streetaddress1"]);
	if ($vendor["streetaddress2"] != "") {
	    PDF_continue_text($pdf, $vendor["streetaddress2"]);
	}
	PDF_continue_text($pdf, $vendor["city"].", ".$vendor["state"]."  ".$vendor["zip"]);
	if ($country != "USA") {
	    PDF_continue_text($pdf, $country);
	}
	PDF_continue_text($pdf, $vendor["phone"]);
	PDF_continue_text($pdf, $vendor["fax"]);
	PDF_continue_text($pdf, $vendor["web"]);
	PDF_continue_text($pdf, $company_contact);
	$relative_ypos -= $p_font * $vendor_ysize;
	/* END VENDOR INFO */


        /* add some blank space. */
	PDF_continue_text($pdf, "");
	$relative_ypos -= $p_font * 1;



	# bottom separation bar
        if (needsPageBreak(0)) { gotoNextPage(); }
	pdf_save($pdf);
	pdf_setcolor($pdf, "both", "rgb", 0.0, 0.0, 1.0, $dummy=1.0);
	pdf_setlinewidth($pdf, 4.0);
	pdf_moveto($pdf, $pwidth-10, $relative_ypos);
	pdf_lineto($pdf, 10, $relative_ypos);
	pdf_stroke($pdf);
	pdf_restore($pdf);


        /* add some blank space. */
	$relative_ypos -= $p_font * 2;


	/* Bill to address */
        $billing_ysize = 7;
        if (needsPageBreak($p_font*$billing_ysize)) { gotoNextPage(); }

	PDF_set_text_pos($pdf, 20, $relative_ypos);
	PDF_show($pdf, "Bill to:  ");
	PDF_set_text_pos($pdf, (20 + $p_font * 5), $relative_ypos);
	PDF_show($pdf, "The University of Michigan");
	PDF_continue_text($pdf, "Physics Department");
	PDF_continue_text($pdf, "2477 Randall Lab.");
	PDF_continue_text($pdf, "500 East University Ave.");
	PDF_continue_text($pdf, "Ann Arbor, MI 48109-1120");
	if ($country != "USA") {
	    PDF_continue_text($pdf, "USA");
	}
	PDF_continue_text($pdf, "Attn:  ");

	/* ship to address */
	PDF_set_text_pos($pdf, ($pwidth - $p_font*25), $relative_ypos);
	PDF_show($pdf, "Ship to:  ");
	PDF_set_text_pos($pdf, ($pwidth - $p_font*20), $relative_ypos);
	PDF_show($pdf, "The University of Michigan");
	PDF_continue_text($pdf, $shiptoaddr["name"]);
	PDF_continue_text($pdf, $shiptoaddr["streetaddress1"]);
	if ($shiptoaddr["streetaddress2"] != "") {
	    PDF_continue_text($pdf, $shiptoaddr["streetaddress2"]);
	}
	PDF_continue_text($pdf, "Ann Arbor, MI  ".$shiptoaddr["zip"]);
	if ($country != "USA") {
	    PDF_continue_text($pdf, "USA");
	}
	PDF_continue_text($pdf, "Attn:  ".$ordered_by["firstname"]." ".$ordered_by["lastname"]);
	$relative_ypos -= $p_font * $billing_ysize;
        /* END BILLING */


	/* and last of all, the 'ordered by' line */
        if (needsPageBreak(0)) { gotoNextPage(); }
	PDF_set_text_pos($pdf, ($pwidth - $p_font*19), $relative_ypos);
	PDF_show($pdf, "Ordered by:_______________________");


	PDF_end_page($pdf);
	PDF_close($pdf);

	$pdf_buf = PDF_get_buffer($pdf);
	$pdf_len = strlen($pdf_buf);

	PDF_delete($pdf);

?>
