<?
   /* (C) COPYRIGHT Spencer Olson 2002-2006 */

	$db = pg_connect($db_connect_str);

        if(!isset($order_by)) {
            $order_by = isset($_REQUEST["order_by"]) ? $_REQUEST["order_by"] : "";
        }

        if(!isset($account)) {
            $account = isset($_REQUEST["account"]) ? $_REQUEST["account"] : "";
        }

        if(!isset($cleared)) {
            $cleared = isset($_REQUEST["cleared"]) ? $_REQUEST["cleared"] : "";
        }

	switch ($order_by) {
	    case "account":
		$ordering = "accountname DESC, po.ordereddate ASC, po.id ASC";
	    	break;

	    case "person":
		$ordering = "per.firstname DESC, per.lastname DESC, po.ordereddate ASC, po.id ASC, accountname DESC";
	    	break;

	    case "vendor":
		$ordering = "vend.name DESC, po.ordereddate ASC, po.id ASC, accountname DESC";
	    	break;

	    case "total":
		$ordering = "subtotal ASC, po.ordereddate ASC, po.id ASC, accountname DESC";
	    	break;

	    case "date":
		$ordering = "po.ordereddate ASC, po.id ASC, accountname DESC";
		break;

	    case "cleared":
		$ordering = "po.cleared DESC, po.id ASC, po.ordereddate ASC, po.id ASC, accountname DESC";
		break;
	    case "id":
	    default:
		$ordering = "po.id ASC, po.ordereddate ASC, po.id ASC, accountname DESC";
	}

	$orders = pg_exec($db, "select	po.id as id,  
					to_char(po.ordereddate, 'DD-Mon-YYYY') as ordereddate,
			        	trim(vend.name) as vendor,  
			        	trim(per.firstname) as firstname,  
			        	trim(per.lastname) as lastname,
					acc.accountnumber as accountnumber,
					trim(acc.name) as accountname,
					po.shippinghandling,
					po.othercharges,
					po.cleared,
					(po.shippinghandling + po.othercharges +  SUM(pi.unitprice * pi.quantity)) as subtotal
			          from	PurchaseOrders po left outer join PurchaseItems pi on (pi.PurchaseID = po.id),
				  	Personnel per,
					Vendors vend,
					Accounts acc  
			         where	po.OrderedByID = per.ID
				   AND	po.VendorID = vend.ID
				   AND	po.AccountNumber = acc.AccountNumber
				   AND	(po.cancelled Is Null Or po.cancelled = 'false') ".
				   (empty($account) ? "" : " AND acc.accountnumber = '".$account."'").
				   (empty($cleared) ? "" : " AND po.cleared = '".$cleared."'")."
				 GROUP	BY po.id,
				 	po.ordereddate,
					po.accountnumber,
					po.shippinghandling,
					po.othercharges,
					po.cancelled,
					po.cleared,
					vend.name,
					per.firstname,
					per.lastname,
					acc.accountnumber,
					acc.name
				 ORDER	BY ".$ordering
			 );

	$this_list = (empty($account)?"":"&account=".$account)
		   . (empty($cleared)?"":"&cleared=".$cleared);
?>
<html><head><title>Past Orders</title>
	<link rel=StyleSheet href="credit.css" type="text/css">
    </head>
    <body>

	<? commonHeader("list_orders");?>

      <table border=1 width=50% cellspacing=0 cellpadding=3>
        <tr>
	  <th><a href="<?echo($this_page)?>?form=list_orders<?echo $this_list;?>&order_by=id">PO_ID</a></th>
	  <th><a href="<?echo($this_page)?>?form=list_orders<?echo $this_list;?>&order_by=date">Date Ordered</a></th>
	  <th><a href="<?echo($this_page)?>?form=list_orders<?echo $this_list;?>&order_by=account">Account</a></th>
	  <th><a href="<?echo($this_page)?>?form=list_orders<?echo $this_list;?>&order_by=person">Ordered By</a></th>
	  <th><a href="<?echo($this_page)?>?form=list_orders<?echo $this_list;?>&order_by=vendor">Ordered From</a></th>
	  <th><a href="<?echo($this_page)?>?form=list_orders<?echo $this_list;?>&order_by=total">Total</a></th>
	  <th><a href="<?echo($this_page)?>?form=list_orders<?echo $this_list;?>&order_by=cleared">Cleared</a></th>
	</tr>
<?
	$this_list .= (empty($order_by)?"":"&order_by=".$order_by);
	if ($orders != false) {
	    for( $n = pg_numrows($orders) - 1; $n >= 0; $n-- ) {
		$row = pg_fetch_array($orders, $n);
		printf("<tr><td><a href=\"%s?form=show_order_info&id=%s\">%s</a></td><td>%s</td><td>%s (%s)</td><td>%s %s</td><td>%s</td><td>$%s</td><td><a href=\"?form=clear_po&id=%s%s\">%s</a></td></tr>\n",
                       $this_page,
                       $row["id"],
                       $row["id"],
                       $row["ordereddate"],
                       $row["accountnumber"],
                       $row["accountname"],
                       $row["firstname"],
                       $row["lastname"],
                       $row["vendor"],
                       number_format($row["subtotal"], 2),
                       $row["id"],
                       $this_page,
                       ($row["cleared"]=='t'?'c':'n'));
	    }
	}
?>

        </table>
    </body>
</html>
<?
	pg_close($db);
	
	exit;

?>
